// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef MULTIPLIER_APB_WRAPPER_HH
#define MULTIPLIER_APB_WRAPPER_HH

#include <cstddef>
#include <stdint.h>
#include "multiplier.hpp"

class multiplier_apb_wrapper
{

public:

    uint32_t pwdata_old;
    bool pwrite_old;
    bool penable_old;
    bool psel_old;
    uint32_t paddr_old;
    bool presetn_old;
    bool pclk_old;
    struct multiplier_apb_wrapper_iostruct{
        bool * pclk;
        bool * presetn;
        uint32_t * paddr;
        bool * psel;
        bool * penable;
        bool * pwrite;
        uint32_t * pwdata;
        bool * pready;
        uint32_t * prdata;

        multiplier_apb_wrapper_iostruct():
            pclk(nullptr),
            presetn(nullptr),
            paddr(nullptr),
            psel(nullptr),
            penable(nullptr),
            pwrite(nullptr),
            pwdata(nullptr),
            pready(nullptr),
            prdata(nullptr)
        {}

        multiplier_apb_wrapper_iostruct( bool * pclk_3, bool * presetn_3, uint32_t
             * paddr_3, bool * psel_3, bool * penable_3, bool * pwrite_3, uint32_t
             * pwdata_3, bool * pready_3, uint32_t * prdata_3 ):
            pclk(pclk_3),
            presetn(presetn_3),
            paddr(paddr_3),
            psel(psel_3),
            penable(penable_3),
            pwrite(pwrite_3),
            pwdata(pwdata_3),
            pready(pready_3),
            prdata(prdata_3)
        {}

        ~multiplier_apb_wrapper_iostruct()
        {}

        bool operator == (const multiplier_apb_wrapper_iostruct & other) const
        {
            if (pclk != other.pclk) return false;
            if (presetn != other.presetn) return false;
            if (paddr != other.paddr) return false;
            if (psel != other.psel) return false;
            if (penable != other.penable) return false;
            if (pwrite != other.pwrite) return false;
            if (pwdata != other.pwdata) return false;
            if (pready != other.pready) return false;
            if (prdata != other.prdata) return false;
            return true;
        }
    };
    multiplier_apb_wrapper_iostruct hif_a2t_data;
    bool clk;
    bool din_rdy;
    uint16_t op1;
    uint16_t op2;
    uint32_t result;
    bool dout_rdy;
    multiplier_apb_wrapper();


    ~multiplier_apb_wrapper();


    multiplier multiplier_0;
    bool clk_new;
    bool din_rdy_new;
    uint16_t op1_new;
    uint16_t op2_new;
    uint32_t result_new;
    bool dout_rdy_new;
    bool process_in_queue;
    bool flag_globact_process_5_executed;
    bool flag_pclk;
    bool flag_globact_process_8_executed;
    bool flag_penable;
    bool flag_dout_rdy;
    bool flag_result;
    bool flag_globact_process_6_globact_process_7_executed;
    bool flag_pwdata;

    void perform_bindings();


    void globact_process_5();


    void globact_process_8();


    void globact_process_9();


    void globact_process_10();


    void globact_process_6_globact_process_7();


    void update_input_queue( bool synch_phase = true );


    void update_event_queue();


    void flag_elaboration();


    void start_of_simulation();


    void initialize();


private:

    multiplier_apb_wrapper( const multiplier_apb_wrapper & );
    const multiplier_apb_wrapper& operator= ( const multiplier_apb_wrapper & );


};


#endif

